const util = require('util');

const exec = util.promisify(require('child_process').exec);

const _require = require('./utils'),
      buildModuleCatalogBuilder = _require.buildModuleCatalogBuilder;

const _require$setup = require('@cloudflare/cli-helpers').setup({
  cliName: 'memsource-cli'
}),
      success = _require$setup.success;
/**
 * dump
 *
 * This command is a temporary solution as we migrate away from memsource. All
 * of the code that dumps the temporary copies of the translation catalogs
 * generated from *.translations.ts files only happens during the memsource
 * upload process. In order to still have these files translated in the interim,
 * we need to dump these files so they can be sent for translations.
 *
 */


const dump = async () => {
  console.log('Processing *.translations.ts files...'); // Write module catalogs as standard JSON catalogs

  try {
    const moduleCatalogBuilderScriptPath = await buildModuleCatalogBuilder();

    const _await$exec = await exec(`node ${moduleCatalogBuilderScriptPath}`),
          stderr = _await$exec.stderr,
          stdout = _await$exec.stdout;

    if (stdout) {
      success(stdout);
    }

    if (stderr) {
      throw new Error(stderr);
    }
  } catch (e) {
    throw new Error(e);
  }

  console.log('Finished generating .json files.');
};

module.exports = dump;