"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var util = require('util');

var exec = util.promisify(require('child_process').exec);

var _require = require('./utils'),
    buildModuleCatalogBuilder = _require.buildModuleCatalogBuilder;

var _require$setup = require('@cloudflare/cli-helpers').setup({
  cliName: 'memsource-cli'
}),
    success = _require$setup.success;
/**
 * dump
 *
 * This command is a temporary solution as we migrate away from memsource. All
 * of the code that dumps the temporary copies of the translation catalogs
 * generated from *.translations.ts files only happens during the memsource
 * upload process. In order to still have these files translated in the interim,
 * we need to dump these files so they can be sent for translations.
 *
 */


var dump = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var moduleCatalogBuilderScriptPath, _yield$exec, stderr, stdout;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log('Processing *.translations.ts files...'); // Write module catalogs as standard JSON catalogs

            _context.prev = 1;
            _context.next = 4;
            return buildModuleCatalogBuilder();

          case 4:
            moduleCatalogBuilderScriptPath = _context.sent;
            _context.next = 7;
            return exec("node ".concat(moduleCatalogBuilderScriptPath));

          case 7:
            _yield$exec = _context.sent;
            stderr = _yield$exec.stderr;
            stdout = _yield$exec.stdout;

            if (stdout) {
              success(stdout);
            }

            if (!stderr) {
              _context.next = 13;
              break;
            }

            throw new Error(stderr);

          case 13:
            _context.next = 18;
            break;

          case 15:
            _context.prev = 15;
            _context.t0 = _context["catch"](1);
            throw new Error(_context.t0);

          case 18:
            console.log('Finished generating .json files.');

          case 19:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[1, 15]]);
  }));

  return function dump() {
    return _ref.apply(this, arguments);
  };
}();

module.exports = dump;